#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		majver		%(echo %{version} | cut -d'.' -f1)
%define		medver		%(echo %{version} | cut -d'.' -f2)
%define		sname		db
#-----------------------------------------------------------------------------
Name		:	libdb
Version		:	5.3.28
Release		:	17.0.10.rel%{?dist}
Summary		:	The Berkeley DB database library for C
Group		:	System Environment/Libraries

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	BSD and LGPLv2 and Sleepycat
URL		:	https://download.samba.org/pub/ldb/

Source0		:	%{sname}-%{version}.tar.gz
#-----------------------------------------------------------------------------
Requires	:	/usr/sbin/ldconfig

#-----------------------------------------------------------------------------
%description
The Berkeley Database (Berkeley DB) is a programmatic toolkit that
provides embedded database support for both traditional and
client/server applications. The Berkeley DB includes B+tree, Extended
Linear Hashing, Fixed and Variable-length record access methods,
transactions, locking, logging, shared memory caching, and database
recovery. The Berkeley DB supports C, C++, Java, and Perl APIs. It is
used by many applications, including Python and Perl, so this should
be installed on all systems.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc LICENSE README
%{_libdir}/libdb-%{majver}.so
%{_libdir}/libdb-%{majver}.%{medver}.so

#-----------------------------------------------------------------------------
%postun
/usr/sbin/ldconfig

%post
/usr/sbin/ldconfig

#=============================================================================
%package		devel
Summary		:	C development files for the Berkeley DB (Version %{majver}) library

Requires	:	%{name}		= %{version}-%{release}
Requires	:	%{name}-cxx	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
The Berkeley Database (Berkeley DB) is a programmatic toolkit that
provides embedded database support for both traditional and
client/server applications. This package contains the header files,
libraries, and documentation for building programs which use the
Berkeley DB.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/db.h
%{_includedir}/db_*.h
%{_libdir}/libdb.so
%{_libdir}/libdb_cxx.so
%{_defaultdocdir}/%{name}-%{version}/*

#=============================================================================
%package		utils
Summary		:	Command line tools for managing Berkeley DB (version %{majver}) databases

Requires	:	%{name}		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		utils
The Berkeley Database (Berkeley DB) is a programmatic toolkit that
provides embedded database support for both traditional and
client/server applications. Berkeley DB includes B+tree, Extended
Linear Hashing, Fixed and Variable-length record access methods,
transactions, locking, logging, shared memory caching, and database
recovery. DB supports C, C++, Java and Perl APIs.

#-----------------------------------------------------------------------------
%files			utils
%defattr(-,root,root,-)
%attr(0555,-,-) %{_bindir}/db_*

#=============================================================================
%package		cxx
Summary		:	The Berkeley DB database library (version %{majver}) for C++

#-----------------------------------------------------------------------------
%description		cxx
The Berkeley Database (Berkeley DB) is a programmatic toolkit that
provides embedded database support for both traditional and
client/server applications. The Berkeley DB includes B+tree, Extended
Linear Hashing, Fixed and Variable-length record access methods,
transactions, locking, logging, shared memory caching, and database
recovery. The Berkeley DB supports C, C++, Java, and Perl APIs. It is
used by many applications, including Python and Perl, so this should
be installed on all systems.

#-----------------------------------------------------------------------------
%files			cxx
%defattr(-,root,root,-)
%{_libdir}/libdb_cxx-%{majver}.so
%{_libdir}/libdb_cxx-%{majver}.%{medver}.so

#=============================================================================
%prep
%setup -q -n %{sname}-%{version}

#-----------------------------------------------------------------------------
#building application
%build

sed -i 							\
  -e 's/\(__atomic_compare_exchange\)/\1_db/'		\
  src/dbinc/atomic.h

pushd build_unix
../dist/configure					\
        --prefix=%{_prefix}				\
	--exec-prefix=%{_exec_prefix}			\
        --sysconfdir=%{_sysconfdir}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--enable-compat185				\
	--enable-dbm					\
	--disable-zlib					\
	--enable-shared					\
	--disable-static				\
	--enable-cxx					\


%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}
popd

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

pushd build_unix
%{__make} 						\
  DESTDIR=%{buildroot}					\
  docdir=%{_defaultdocdir}/%{name}-%{version}		\
  install

popd

#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.la					\
	-delete

#XXX Avoid Permission denied. strip when building as non-root.
chmod +x %{buildroot}%{_libdir}/*.so*
chmod u+x %{buildroot}%{_bindir}/db_*

#-----------------------------------------------------------------------------
%changelog
